version: '3'
services:
  plex:
    image: plexinc/pms-docker:plexpass
    restart: always
    container_name: plex
    volumes:
      - {{ data_path }}/plexmediaserver/:/config
      - /mnt/:/mnt
    environment:
      - PLEX_UID=1001
      - PLEX_GID=1001
      - TZ="Europe/London"
      - PLEX_CLAIM={{ plex_claim_token.stdout }}
    network_mode: host
    
  tautulli:
    image: tautulli/tautulli:latest
    restart: always
    container_name: tautulli
    volumes:
      - {{ data_path }}/plexpy:/config
      - {{ data_path }}/plexpy/logs:/logs:ro
    environment:
      - TZ="Europe/London"
    networks:
      - proxy

  db:
    image: mariadb
    restart: always
    container_name: nextcloud-db
    command: --transaction-isolation=READ-COMMITTED --binlog-format=ROW
    volumes:
      - {{ data_path }}/nextcloud/mariadb:/var/lib/mysql
    environment:
      - MYSQL_ROOT_PASSWORD={{ mysql["root_password"] }}
      - MYSQL_PASSWORD={{ mysql["password"] }}
      - MYSQL_DATABASE={{ mysql["database"] }}
      - MYSQL_USER={{ mysql["user"] }}
    networks:
      - proxy

  app:
    image: nextcloud:latest
    restart: always
    container_name: nextcloud-app
    ports:
      - 8080:80
    links:
      - db
    volumes:
      - {{ data_path }}/nextcloud/app:/var/www/html
    networks:
      - proxy

  nginx:
    image: nginx:latest
    restart: always
    container_name: nginx-selfhost
    volumes:
      - {{ data_path }}/certbot/conf:/etc/letsencrypt
      - {{ data_path }}/certbot/www:/var/www/certbot
      - {{ prod_path }}/nginx.conf:/etc/nginx/nginx.conf:ro
    ports:
      - "80:80"
      - "443:443"
    command: "/bin/sh -c 'while :; do sleep 6h & wait $${!}; nginx -s reload; done & nginx -g \"daemon off;\"'" # reload config (incl. certs) every 6h
    networks:
      - proxy
  
  certbot:
    image: certbot/certbot
    restart: always
    container_name: certbot-selfhost
    volumes:
      - {{ data_path }}/certbot/conf:/etc/letsencrypt
      - {{ data_path }}/certbot/www:/var/www/certbot
    entrypoint: "/bin/sh -c 'trap exit TERM; while :; do certbot renew; sleep 12h & wait $${!}; done;'" # check cert renewal every 12h

networks: 
  proxy: